=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentGenericContentsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a generic content
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @return [AsyncOperationResponse]
    def create(relative_path, opts = {})
      data, _status_code, _headers = create_with_http_info(relative_path, opts)
      data
    end

    # Create a generic content
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(relative_path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentGenericContentsApi.create ...'
      end
      # verify the required parameter 'relative_path' is set
      if @api_client.config.client_side_validation && relative_path.nil?
        fail ArgumentError, "Missing the required parameter 'relative_path' when calling ContentGenericContentsApi.create"
      end
      if @api_client.config.client_side_validation && relative_path.to_s.length < 1
        fail ArgumentError, 'invalid value for "relative_path" when calling ContentGenericContentsApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/content/deb/generic_contents/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['relative_path'] = relative_path
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['upload'] = opts[:'upload'] if !opts[:'upload'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentGenericContentsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List generic contents
    # GenericContent is a catch all category for storing files not covered by any other type.  Associated artifacts: Exactly one arbitrary file that does not match any other type.  This is needed to store arbitrary files for use with the verbatim publisher. If you are not using the verbatim publisher, you may ignore this type.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebGenericContentResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List generic contents
    # GenericContent is a catch all category for storing files not covered by any other type.  Associated artifacts: Exactly one arbitrary file that does not match any other type.  This is needed to store arbitrary files for use with the verbatim publisher. If you are not using the verbatim publisher, you may ignore this type.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebGenericContentResponseList, Integer, Hash)>] PaginateddebGenericContentResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentGenericContentsApi.list ...'
      end
      allowable_values = ["-_artifacts", "-content_ptr", "-contentartifact", "-group_roles", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-relative_path", "-repositories", "-sha256", "-timestamp_of_interest", "-upstream_id", "-user_roles", "-version_memberships", "_artifacts", "content_ptr", "contentartifact", "group_roles", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "relative_path", "repositories", "sha256", "timestamp_of_interest", "upstream_id", "user_roles", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/generic_contents/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebGenericContentResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentGenericContentsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a generic content
    # GenericContent is a catch all category for storing files not covered by any other type.  Associated artifacts: Exactly one arbitrary file that does not match any other type.  This is needed to store arbitrary files for use with the verbatim publisher. If you are not using the verbatim publisher, you may ignore this type.
    # @param deb_generic_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebGenericContentResponse]
    def read(deb_generic_content_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_generic_content_href, opts)
      data
    end

    # Inspect a generic content
    # GenericContent is a catch all category for storing files not covered by any other type.  Associated artifacts: Exactly one arbitrary file that does not match any other type.  This is needed to store arbitrary files for use with the verbatim publisher. If you are not using the verbatim publisher, you may ignore this type.
    # @param deb_generic_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebGenericContentResponse, Integer, Hash)>] DebGenericContentResponse data, response status code and response headers
    def read_with_http_info(deb_generic_content_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentGenericContentsApi.read ...'
      end
      # verify the required parameter 'deb_generic_content_href' is set
      if @api_client.config.client_side_validation && deb_generic_content_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_generic_content_href' when calling ContentGenericContentsApi.read"
      end
      # resource path
      local_var_path = '{deb_generic_content_href}'.sub('{' + 'deb_generic_content_href' + '}', CGI.escape(deb_generic_content_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebGenericContentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentGenericContentsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
