=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentInstallerFileIndicesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an installer file index
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one 'SHA256SUMS' and/or 'MD5SUMS' file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param deb_installer_file_index [DebInstallerFileIndex] 
    # @param [Hash] opts the optional parameters
    # @return [DebInstallerFileIndexResponse]
    def create(deb_installer_file_index, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_installer_file_index, opts)
      data
    end

    # Create an installer file index
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one &#39;SHA256SUMS&#39; and/or &#39;MD5SUMS&#39; file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param deb_installer_file_index [DebInstallerFileIndex] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebInstallerFileIndexResponse, Integer, Hash)>] DebInstallerFileIndexResponse data, response status code and response headers
    def create_with_http_info(deb_installer_file_index, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentInstallerFileIndicesApi.create ...'
      end
      # verify the required parameter 'deb_installer_file_index' is set
      if @api_client.config.client_side_validation && deb_installer_file_index.nil?
        fail ArgumentError, "Missing the required parameter 'deb_installer_file_index' when calling ContentInstallerFileIndicesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/installer_file_indices/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_installer_file_index) 

      # return_type
      return_type = opts[:return_type] || 'DebInstallerFileIndexResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentInstallerFileIndicesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List InstallerFileIndices
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one 'SHA256SUMS' and/or 'MD5SUMS' file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebInstallerFileIndexResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List InstallerFileIndices
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one &#39;SHA256SUMS&#39; and/or &#39;MD5SUMS&#39; file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :component Filter results where component matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebInstallerFileIndexResponseList, Integer, Hash)>] PaginateddebInstallerFileIndexResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentInstallerFileIndicesApi.list ...'
      end
      allowable_values = ["-_artifacts", "-architecture", "-component", "-content_ptr", "-contentartifact", "-group_roles", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-relative_path", "-release", "-repositories", "-sha256", "-timestamp_of_interest", "-upstream_id", "-user_roles", "-version_memberships", "_artifacts", "architecture", "component", "content_ptr", "contentartifact", "group_roles", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "relative_path", "release", "repositories", "sha256", "timestamp_of_interest", "upstream_id", "user_roles", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/installer_file_indices/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'component'] = opts[:'component'] if !opts[:'component'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebInstallerFileIndexResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentInstallerFileIndicesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an installer file index
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one 'SHA256SUMS' and/or 'MD5SUMS' file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param deb_installer_file_index_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebInstallerFileIndexResponse]
    def read(deb_installer_file_index_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_installer_file_index_href, opts)
      data
    end

    # Inspect an installer file index
    # An InstallerFileIndex represents the indices for a set of installer files.  Associated artifacts: Exactly one &#39;SHA256SUMS&#39; and/or &#39;MD5SUMS&#39; file.  Each InstallerFileIndes is associated with a single component-architecture combination within a single Release. Note that installer files are currently used exclusively for verbatim publications. The APT publisher (both simple and structured mode) does not make use of installer content.
    # @param deb_installer_file_index_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebInstallerFileIndexResponse, Integer, Hash)>] DebInstallerFileIndexResponse data, response status code and response headers
    def read_with_http_info(deb_installer_file_index_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentInstallerFileIndicesApi.read ...'
      end
      # verify the required parameter 'deb_installer_file_index_href' is set
      if @api_client.config.client_side_validation && deb_installer_file_index_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_installer_file_index_href' when calling ContentInstallerFileIndicesApi.read"
      end
      # resource path
      local_var_path = '{deb_installer_file_index_href}'.sub('{' + 'deb_installer_file_index_href' + '}', CGI.escape(deb_installer_file_index_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebInstallerFileIndexResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentInstallerFileIndicesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
