=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentReleaseFilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a release file
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of 'Release' and 'InRelease' file. If the 'Release' file is present, then there may also be a 'Release.gpg' detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Release' files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param deb_release_file [DebReleaseFile] 
    # @param [Hash] opts the optional parameters
    # @return [DebReleaseFileResponse]
    def create(deb_release_file, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_release_file, opts)
      data
    end

    # Create a release file
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of &#39;Release&#39; and &#39;InRelease&#39; file. If the &#39;Release&#39; file is present, then there may also be a &#39;Release.gpg&#39; detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Release&#39; files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param deb_release_file [DebReleaseFile] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebReleaseFileResponse, Integer, Hash)>] DebReleaseFileResponse data, response status code and response headers
    def create_with_http_info(deb_release_file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseFilesApi.create ...'
      end
      # verify the required parameter 'deb_release_file' is set
      if @api_client.config.client_side_validation && deb_release_file.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_file' when calling ContentReleaseFilesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_files/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_release_file) 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseFileResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseFilesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List release files
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of 'Release' and 'InRelease' file. If the 'Release' file is present, then there may also be a 'Release.gpg' detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Release' files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebReleaseFileResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List release files
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of &#39;Release&#39; and &#39;InRelease&#39; file. If the &#39;Release&#39; file is present, then there may also be a &#39;Release.gpg&#39; detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Release&#39; files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebReleaseFileResponseList, Integer, Hash)>] PaginateddebReleaseFileResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseFilesApi.list ...'
      end
      allowable_values = ["-_artifacts", "-architectures", "-artifact_set_sha256", "-codename", "-components", "-content_ptr", "-contentartifact", "-deb_installerfileindex", "-deb_packageindex", "-distribution", "-group_roles", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-relative_path", "-repositories", "-sha256", "-suite", "-timestamp_of_interest", "-upstream_id", "-user_roles", "-version_memberships", "_artifacts", "architectures", "artifact_set_sha256", "codename", "components", "content_ptr", "contentartifact", "deb_installerfileindex", "deb_packageindex", "distribution", "group_roles", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "relative_path", "repositories", "sha256", "suite", "timestamp_of_interest", "upstream_id", "user_roles", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/release_files/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'codename'] = opts[:'codename'] if !opts[:'codename'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'suite'] = opts[:'suite'] if !opts[:'suite'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebReleaseFileResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseFilesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a release file
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of 'Release' and 'InRelease' file. If the 'Release' file is present, then there may also be a 'Release.gpg' detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any 'Release' files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param deb_release_file_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebReleaseFileResponse]
    def read(deb_release_file_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_release_file_href, opts)
      data
    end

    # Inspect a release file
    # A ReleaseFile represents the Release file(s) from a single APT distribution.  Associated artifacts: At least one of &#39;Release&#39; and &#39;InRelease&#39; file. If the &#39;Release&#39; file is present, then there may also be a &#39;Release.gpg&#39; detached signature file for it.  Note: The verbatim publisher will republish all associated artifacts, while the APT publisher (both simple and structured mode) will generate any &#39;Release&#39; files it needs when creating the publication. It does not make use of ReleaseFile content.
    # @param deb_release_file_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebReleaseFileResponse, Integer, Hash)>] DebReleaseFileResponse data, response status code and response headers
    def read_with_http_info(deb_release_file_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleaseFilesApi.read ...'
      end
      # verify the required parameter 'deb_release_file_href' is set
      if @api_client.config.client_side_validation && deb_release_file_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_file_href' when calling ContentReleaseFilesApi.read"
      end
      # resource path
      local_var_path = '{deb_release_file_href}'.sub('{' + 'deb_release_file_href' + '}', CGI.escape(deb_release_file_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseFileResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleaseFilesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
